This project is meant to provide the integration between jDEECo (Java) and the OMNET++ simulation framework (C++).
JNI is used in the implementation and as an output of the project a shared library is produced that provides native API for communicating with the simulation.

#### Building the project (WINDOWS):
* In oreder to build and use the library the OMNET++ distribution needs to be rebuild with slightly modified configuration. The modified config.user file is in the "omnet-config" directory and needs to be placed in the root directory of the OMNET++ installation. Specifically it directs building process to statically link some of the libraries that may conflict with other libraries in the system. To rebuild the OMNET++ please follow the process described in the manual.
* Another part is to configure properly the eclipse project. The project requires includes that are provided by the OMNET++ and as such in the Project Properties > C\C++ General > Paths and Symbols > Includes please add path to the "include" directory in your OMNET++ installation.
* Similarly the project needs to be linked with the OMNET++ libraries so in the Project Properties > C\C++ General > Paths and Symbols > Library Paths please point to the "bin" directory of the OMNET++ project. Alternatively, if you did not rebuild the OMNET++ distribution (see the first bullet) you can use libraries given in the project. For that you need to set "Library paths" to project location ("."). In the "Libraries" tab please add following entries "oppsim", "oppenvir" and "oppcommon".

#### Usage in OMNET++:
In order to connect the OMNET++ simulation with jDEECo, one needs to create a simple module that inherits (pure C++ inheritance, not in NED file) from the jDEECoModule class. Appropriate headers files can be found in the project so an inclusion pointing to the project location is necessary. Also the reference to the integration library is necessary and it needs to be set in the "Library paths" tab in the Project Properties > C\C++ General > Paths and Symbols to point also to this project location.
Because OMNET++ relies on the Makemake, setting up particular libraries reference is different than previously. For that one needs to open the Project Properties > OMNt++ > Makemake > [configuration] > Options > Link > More and in the "Additional libraries to link" put "integration". Also in the Project Properties > OMNt++ > Makemake > [configuration] > Options > Target tab please select shared library. This shared library will be loaded when jDEECo is run. However, this step should be done at the end of the development of the network topology.

#### Usage with jDEECo:
To use the developed (in OMNet++) network topology one needs to provide all necessary libraries (i.e. main library + library used in the project such as iNET, Mixims, ....). All of them should be compiled in the relase mode so the correct libraries are loaded. Additionally, in the omnetpp.ini file please update the "load-libs" entry, which is the (white space separted) list of additional libraries that needs to be loaded for the simulation.
